package de.uni_marburg.powersort.benchmark;

import de.uni_marburg.powersort.data.RandomIntegers;
import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;

// TODO: The parameters are way too low. Use for debugging only!
/*
 * Benchmark parameters
 */
@Fork(0)
@Warmup(iterations = 0)
@Measurement(iterations = 1)
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.MILLISECONDS)
/*
 * Benchmark state parameters
 *
 * Quote from JMH:
 * State objects naturally encapsulate the state on which benchmark is working on.
 */
@State(Scope.Benchmark)
public abstract class AbstractBenchmark {
    private final RandomIntegers readonly = new RandomIntegers();
    /* package-protected */ Integer[] array;

    // TODO: This is inaccurate. How to create and use separate arrays for each warmup x iteration x sortAlgorithm ?
    @Setup(Level.Invocation)
    public void setup() {
        array = readonly.getCopy();
    }

    @Benchmark
    public void benchmark() {
        sort();
    }

    /**
     * Sorts this.array with some sorting algorithm.
     */
    /* package-protected */ abstract void sort();
}
