package de.uni_marburg.powersort.sort;

import java.util.Arrays;
import java.util.Comparator;

/**
 * Same class and method interface as JDK23 TimSort.java with its sort() method.
 * <p>
 * Uses Arrays.sort() for sorting.
 */
public class DummySort {
    public static <T> void sort(T[] a, int lo, int hi, Comparator<? super T> c,
                                T[] work, int workBase, int workLen) {
        assert lo == 0;
        assert hi == a.length;
        assert work == null;
        Arrays.sort(a, c);
    }
}
